#ifndef BUTTON_H
#define BUTTON_H

#include "Arduino.h"

//==================Button class========================

/// \author silhavyj A17B0362P
///
/// This class sepresents the reset button the user
/// is required to press after a water leak has been
/// detected of they want to reset the device.
class Button {

//====================private data======================
private:
    int pin;                ///< number of the pin the button si connected to
    int currentInputValue;  ///< current state of the input pin
    int previousInputValue; ///< previous state of the input pin

//==================public methods======================
public:
    /// Constructor of the class
    /// \param pin number of the pin the button si connected to
    Button(int pin);

    /// Tests if the button is being pressed
    ///
    /// It reads the state of the input pin if it has gone
    /// from LOW to HIGH, the method will return 1 as the 
    /// button is being pressed.
    ///
    /// \return 1 if the button is being pressed. Otherwise, 0.
    int isPressed();
};

#endif