#ifndef I_DISPLAYABLE_H_
#define I_DISPLAYABLE_H_

#include "Arduino.h"

//================IDisplayable class====================

/// \author silhavyj A17B0362P
///
/// This class works as an interface for all classes
/// that want to display some information on the LCD.
class IDisplayable {
public:
    /// Returns the content of the row given as a parameter.
    ///
    /// One class represents one page on the LCD display.
    /// Each of the 4 rows has different content identified
    /// by the number of the row.
    ///
    /// \param row number of the row
    /// \return content to be displayed on that row of the LCD
    virtual const String getRow(int row) const = 0;
};

#endif