#ifndef I_LOGGABLE_H_
#define I_LOGGABLE_H_

#include "Arduino.h"

//==================ILoggable class=====================

/// \author silhavyj A17B0362P
///
/// This class works as an interface for all classes
/// that want to be able to print out some information
/// in the terminal when logging (debugging) is enabled.
class ILoggable {
public:
    /// Returns the log description (body) of the class
    /// \return the content of the log being printed out
    virtual const String getLogDescription() const = 0;

    /// Returns the log id of the class
    /// \return the log id
    virtual const String getLogID() const = 0;
};

#endif