#ifndef PINS_H
#define PINS_H

#include "Setup.h"

//==================sensor pin==========================
#ifdef UNIT_TEST
# define SENSOR_PIN A14 ///< when Unit testing, the sensor pin is 14 (artificially generated pulses)
# else
# define SENSOR_PIN 2  ///< the flow sensor
#endif

//==================main valve==========================
#define VALVE_PIN               8 ///< main valve     
#define VALVE_LED_PIN           9 ///< main valve LED

//=================reset buttons========================
#define VALVE_MANUAL_CLOSE_PIN 23 ///< "manual close" button
#define RESET_PIN              26 ///< reset button

//==================home alarm==========================
#define HOME_ALARM_PIN         24 ///< home alarm

//================HIGH water leak=======================
#define HIGH_BYPASS_PIN        49 ///< high-water leak bypass button
#define HIGH_ILOCK_LED_PIN     48 ///< high-water leak LED (detected = on)

//=================LOW water leak=======================
#define LOW_BYPASS_PIN         47 ///< low-water leak bypass button
#define LOW_ILOCK_LED_PIN      46 ///< low-water leak LED (detected = on)

//================TOTAL water leak======================
#define TOTAL_BYPASS_PIN       45 ///< total-water leak bypass button
#define TOTAL_ILOCK_LED_PIN    44 ///< total-water leak bypass button

//==============PINs initialization=====================
#define CONFIG_PINS \
  pinMode(SENSOR_PIN,             INPUT);  \
  pinMode(HIGH_BYPASS_PIN,        INPUT);  \
  pinMode(LOW_BYPASS_PIN,         INPUT);  \
  pinMode(RESET_PIN,              INPUT);  \
  pinMode(TOTAL_BYPASS_PIN,       INPUT);  \
  pinMode(HOME_ALARM_PIN,         INPUT);  \
  pinMode(VALVE_PIN,              OUTPUT); \
  pinMode(VALVE_MANUAL_CLOSE_PIN, INPUT);  \
  pinMode(HIGH_ILOCK_LED_PIN,     OUTPUT); \
  pinMode(LOW_ILOCK_LED_PIN,      OUTPUT); \
  pinMode(TOTAL_ILOCK_LED_PIN,    OUTPUT); \
  pinMode(VALVE_LED_PIN,          OUTPUT); \
  digitalWrite(VALVE_PIN, HIGH);  // don't close the main valve when booting up
                                  // 0=close; 1=open
#endif