#ifndef SETUP_H
#define SETUP_H

//===================Unit testing=======================

// #define UNIT_TEST

//===============General functionality==================

#ifndef UNIT_TEST
//# define DEBUG                    ///< enable debugging
//# define HOME_ALARM_SETTINGS      ///< allow home alarm settings
# define WEB_SERVER                 ///< enable the webserver
# define LCD_DISPLAY                ///< enable the LCD display
#else
# define GENERATE_PULSES            ///< enable the pulse generator
# define EMAIL_NOTIFICATION         ///< enable email notifications
#endif

#define SENSOR_PULSE_IN_LITERS 10   ///< the low sensor constant (10 liters = 1 pulse)    

#define DAILY_OVERVIEW_INIT_HOUR 15 ///< hour when the daily overview email will be sent off
#define DAILY_OVERVIEW_INIT_MIN  00 ///< minute when the daily overview email will be sent off

#define SERIAL_BAUD_RATE 9600       ///< baud rate for the serial communication (terminal)

#define SETTINGS_FILE_NAME "CONFIG.TXT"        ///< the main settings file stored on the SD card
#define BACKUP_SETTINGS_FILE_NAME "backup.txt" ///< temporary backup file for the settings

#define SS_SD_CARD 4                ///< SD card pin (arduino documentation) 
#define SS_ETHERNET 10              ///< etherent pin (arduino documentation) 

//===============Email notifications====================

#ifdef WEB_SERVER
//# define EMAIL_NOTIFICATION       ///< enable e-mail notifications
#endif

//================Pulse genearator======================

#ifdef GENERATE_PULSES
# define PG_DELAY_HIGH 100          ///< delay of the pulse in the HIGH position (ms) 
# define PG_DELAY_LOW 60000         ///< delay of the pulse in the LOW position (ms)
# define PG_PIN A15                 ///< pin where the pulses will be generated
#endif

#endif
