#ifndef TIME_PERIOD_H
#define TIME_PERIOD_H

#include "Arduino.h"
#include "DateTime.h"

//==================TimePeriod class====================

/// \author silhavyj A17B0362P
///
/// This class is used for counting down a certail period
/// of time, for example, 2s. This class is used, for example,
/// in the LCD controller 
class TimePeriod {
    
//====================private data======================
private:
    time_t period;      ///< the period of tme, e.g. 2s
    time_t lastActive;  ///< last time stamp from which the period of time is being measured

//==================public methods======================
public:
    /// Constructor of the class
    /// \param period period of time that will be counted down
    TimePeriod(time_t period);

    /// Returns information if the period of time has passed
    /// \return true if the amount of time has passed, false otherwise
    int isActive();
};

#endif