#include "DateTime.h"

DateTime* DateTime::instance = NULL;

#ifdef WEB_SERVER
    String HTML_startDate(const DateTime& dateTime);
    String HTML_startTime(const DateTime& dateTime);
#endif

DateTime::DateTime() {
    rtc.begin();

    // SETTING THE DATE TIME for the first time
    // rtc.setDateTime(__DATE__, __TIME__);

    startTime = getTimeStr(); // time when the device started
    startDate = getDateStr(); // date when the device started

    #ifdef WEB_SERVER
        // functions providing data to the webserver
        htmlData[130] = &HTML_startDate;
        htmlData[190] = &HTML_startTime;
    #endif
}

DateTime* DateTime::getInstance() {
    if (instance == NULL)
        instance = new DateTime;
    return instance;
}

String DateTime::getTimeStr() const {
    RTCDateTime dateTime = rtc.getDateTime();
    String time = String(FORMAT_2_DIGITS(dateTime.hour)) + ":" +
                  String(FORMAT_2_DIGITS(dateTime.minute));
    return time;
}

String DateTime::getDateStr() const {
    RTCDateTime dateTime = rtc.getDateTime();
    String date = String(dateTime.day) + "." +
                  String(dateTime.month) + "." +
                  String(dateTime.year);
    return date;
}

String DateTime::getDateTimeStr() const {
    return getDateStr() + " | " + getTimeStr();
}

RTCDateTime DateTime::getDateTime() const {
    return rtc.getDateTime();
}

#ifdef WEB_SERVER
    const String DateTime::getHTMLData(const int id) const {
        auto fce = htmlData.find(id);
        if (fce == htmlData.end())
            return HTMLDataSource::UNDEFINED_DATA;
        return fce->second(*this);
    }

    String HTML_startDate(const DateTime& dateTime) {
        return dateTime.startDate;
    }

    String HTML_startTime(const DateTime& dateTime) {
        return dateTime.startTime;
    }
#endif
