#include "Logger.h"

Logger* Logger::instance = NULL;

Logger* Logger::getInstance() {
    if (instance == NULL) instance = new Logger;
    return instance;
}

void Logger::addEntity(ILoggable* log) {
    logs.push_back(log);
}

void Logger::update() {
    if (timePeriod.isActive()) {
        Serial.println();
        for (const auto log : logs) {
            Serial.print("[");
            Serial.print(FORMAT_TIME(millis()));
            Serial.print("]");
            Serial.print(log->getLogID());
            Serial.println(log->getLogDescription());
        }
    }
};