#include <Arduino.h>
#include <ArduinoSTL.h>
#include <unity.h>

#include <Pins.h>
#include <DateTime.h>
#include <PulseGenerator.h>
#include <PulseCounter.h>
#include <HighLeakDetection.h>
#include <LowLeakDetection.h>
#include <TotalLeakDetection.h>
#include <LeakDetectionConfig.h>
#include <ALeakDetectable.h>
#include <FreeMemoryMeasurement.h>

#define BAUD_RATE 9600
#define NOT_USED 0
#define PULSE_SOURCE_PIN A15
#define INITIAL_DELAY SEC_TO_MILLIS(2)

PulseCounter pulseCounter(SENSOR_PIN);
ALeakDetectable *leakDetection = NULL;
PulseGenerator *pulseGenerator = NULL;

int totalNumberOfPulses = %number_of_generated_pulses%;
int expectedResult = %expected_result%;

void setup() {
    CONFIG_PINS
    Serial.begin(BAUD_RATE);
    while (!Serial)
        ;
    delay(INITIAL_DELAY);
    UNITY_BEGIN();
}

void testResultOfDetection() {
    int actual = leakDetection->isActive();
    TEST_ASSERT_EQUAL(expectedResult, actual);
}

void loop() {
    leakDetection = new %type%LeakDetection(&pulseCounter, ALeakDetectable::%type%, {%reset_time%, %time_action%, %pulses_limit_action%, %bypass%_BYPASS_PIN}, {});
    pulseGenerator = new PulseGenerator(%delay_high%, %delay_low%, PULSE_SOURCE_PIN);

    int numberOfGeneratedPulses = 0;
    while (numberOfGeneratedPulses < totalNumberOfPulses) {
        pulseGenerator->update();
        pulseCounter.update();
        leakDetection->update();

        if (leakDetection->isActive())
            break;
       
        if (pulseCounter.isActive())
            numberOfGeneratedPulses++;
    }
    RUN_TEST(testResultOfDetection);

    delete leakDetection;
    delete pulseGenerator;

    UNITY_END();
}