import os
import shutil
import subprocess

http_rq_settings_test_template = open('templates/HTTPRequestSettings.cpp').read()
http_rq_notification_test_template = open('templates/HTTPRequestNotification.cpp').read()

def clean_test_dir():
    sub_folders = [f.path for f in os.scandir('../test') if f.is_dir()]
    for dir_name in list(sub_folders):
        sub_folders.extend(fast_scandir(dir_name))
        shutil.rmtree(dir_name)

def fast_scandir(dir_name):
    sub_folders = [f.path for f in os.scandir(dir_name) if f.is_dir()]
    for dir_name in list(sub_folders):
        sub_folders.extend(fast_scandir(dir_name))
    return sub_folders

def execute_tests():
    p = subprocess.Popen(['platformio', 'test'], cwd='../')
    p.wait()

def copy_src_files():
    unit_test_dirs = fast_scandir('../test')
    src_files = os.listdir('../src')
    src_files.remove('main.cpp')

    for file_name in src_files:
        full_file_name = os.path.join('../src', file_name)
        if os.path.isfile(full_file_name):
            for unit_test_dir in unit_test_dirs:
                shutil.copy(full_file_name, unit_test_dir)

clean_test_dir()
os.mkdir('../test' + '\\' + 'HTTPRequestSettings')
open('../test/HTTPRequestSettings/' + 'HTTPRequestSettings' + '.cpp', "w+").write(http_rq_settings_test_template)
os.mkdir('../test' + '\\' + 'HTTPRequestNotification')
open('../test/HTTPRequestNotification/' + 'HTTPRequestNotification' + '.cpp', "w+").write(http_rq_notification_test_template)
copy_src_files()
execute_tests()
clean_test_dir()